Skip to main content

Priority_queue Question 1

Leetcode 857 Minimum Cost to Hire K Workers

There are n workers. You are given two integer arrays quality and wage where quality[i] is the quality of the ith worker and wage[i] is the minimum wage expectation for the ith worker.

We want to hire exactly k workers to form a paid group. To hire a group of k workers, we must pay them according to the following rules:

Every worker in the paid group should be paid in the ratio of their quality compared to other workers in the paid group.

Every worker in the paid group must be paid at least their minimum-wage expectation.

Given the integer k, return the least amount of money needed to form a paid group satisfying the above conditions. Answers within 10-5 of the actual answer will be accepted.

Constraints:

n == quality.length == wage.length

1 <= k <= n <= 10^4

1 <= quality[i], wage[i] <= 10^4


Analysis:

The first step is to get the wage/quality ratio. 

Let focus on a small size first: we have two people only, (q1, r1) and (q2, r2), where q is quality and r is the wage/quality ratio. If r1 > r2, and we choose to pay the first worker with his minimum wage expectation, so the ratio is r1; then we need to pay the second worker with q2*r1. So the wage/quality ratio for the second worker is the same as that for the first worker. Since r1 is higher than r2, the plan is valid for both workers.

If we choose to pay the second worker with his minimum wage expectation, then we need to pay the first worker with q1*r2, which is not a valid plan since r2 < r1, because the minimum payment requires to pay the first worker with the ratio of r1. If we adjust the payment ratio for the first worker to be r1, then this payment plan is the same as that in the first plan of payment.

After running the test case with a very small size, we can make the following conclusions:

1. for a group of people, we can always use the one with the highest ratio as the base. Then all the rest people having a smaller ratio can be payed with the same ratio, and the payment plan is always valid;

2. after determining the base and the ratio, then we need to use the ones with the smallest qualities. Why? because the payment is ratio*quality.

So now it is relative clear: we need to sort the workers by their wage/quality ratios. Then, once a worker is chosen as the base, then all the workers before him (having smaller ratios) can be picked up in the team with the same payment ratio as the base (the reason is in 1 above). Then we need to pick up the workers with top-k smallest qualities (the reason is in 2 above), which will give the lowest cost for k workers with the first worker picked as the payment base.

Now let think about how to code. The first step can be implemented by sorting; for the second step, we need to pick up the workers with the top-k smallest qualities, so priority_queue becomes one of the choices.


See the code below:

class Solution {
public:
    double mincostToHireWorkers(vector<int>& quality, vector<int>& wage, int k) {
        double res = INT_MAX;
        int n = quality.size();
        vector<pair<int, double>> data;
        for(int i=0; i<n; ++i) {
            data.push_back({quality[i], wage[i]*1.0/quality[i]});
        }
        sort(data.begin(), data.end(), [](auto &a, auto &b){    
            return a.second < b.second;
        });
        int sum = 0;
        priority_queue<int> pq;
        for(int i=0; i<n; ++i) {
            int t = data[i].first;
            double d = data[i].second;
            sum += t;
            pq.push(t);
            if(pq.size() >= k) {
                if(pq.size() > k) {
                    sum -= pq.top();
                    pq.pop();
                }
                double one = d*sum;
                res = min(res, one);
            }
        }
        return res;
    }
};


 

Upper Layer

Comments

Popular posts from this blog

Segment Tree

Segment tree can be viewed as an abstract data structure which using some more space to trade for speed. For example, for a typical question with O(N^2) time complexity, the segment tree method can decrease it to O(N*log(N)).  To make it understandable, let us consider one example. Say we have an integer array of N size, and what we want is to query the maximum with a query range [idx1, idx2], where idx1 is the left indexes, and idx2 is the right indexes inclusive. If we only do this kind of query once, then we just need to scan through the array from idx1 to idx2 once, and record the maximum, done. The time complexity is O(N), which is decent enough in most cases even though it is not the optimal one (for example, with a segment tree built, the time complexity can decrease down to O(log(N))). However, how about we need to query the array N times? If we continue to use the naïve way above, then the time complexity is O(N^2), since for each query we need to scan the query range once. We

Binary Search - Hard Level - Question 3

Binary Search - Hard Level - Question 3 878. Nth Magical Number A positive integer is magical if it is divisible by either a or b. Given the three integers n, a, and b, return the nth magical number. Since the answer may be very large, return it modulo 10^9 + 7. Analysis: Let us consider some examples first. Example 1, a = 4, b = 2. If b is dividable by a, then all the numbers which is dividable by a should be dividable by b as well. So the nth magical number should be n*b; Example 2, a = 3, b = 2. The multiples of 2 are: 2, 4, 6, 8, 10, 12, ... The multiple of 3 are: 3, 6, 9, 12, ... So the overlap is related to the minimum common multiple between a and b, and we need to remove the overlap which is double-counted. So now, we make some conclusions: 1. the upper bound of the nth magical number should be n*b, where a is the smaller one (or b <= a); 2. there are n*b/a magical numbers smaller than n*b; 3. there are n*b/(minimum common multiple) overlaps. Thus, the overall count is: n +

Recursion - Example

Recursion - Example Leetcode 231  Power of Two Given an integer n, return true if it is a power of two. Otherwise, return false. An integer n is a power of two, if there exists an integer x such that n == 2^x Constraints: -2^31 <= n <= 2^31 - 1 Analysis: One way is to think about this question recursively: if n%2 == 1, then n must not be power of 2; if not, then we just need to consider whether (n/2) is a power of 2 or not. This is exactly the "same question with a smaller size"! It is trivial to figure out the base cases: if n == 0, return false; if n == 1, return true. See the code below: class Solution { public: bool isPowerOfTwo(int n) { // base cases if(n == 0) return false; if(n == 1) return true; // converging if(n%2 == 1) return false; return isPowerOfTwo(n/2); } }; If interested, there are some other ways to solve this problem. For example, using bit manipulation, we can have the following solution: class